[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[PATCH 3/8] split: add tests
From: |
Jim Meyering |
Subject: |
[PATCH 3/8] split: add tests |
Date: |
Sat, 30 Apr 2011 15:31:04 +0200 |
From: Jim Meyering <address@hidden>
* tests/Makefile.am (TESTS): Add split/filter.
* tests/split/filter: New file.
---
tests/Makefile.am | 1 +
tests/split/filter | 41 +++++++++++++++++++++++++++++++++++++++++
2 files changed, 42 insertions(+), 0 deletions(-)
create mode 100755 tests/split/filter
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 52417bc..6a8b79d 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -247,6 +247,7 @@ TESTS = \
misc/sort-unique \
misc/sort-unique-segv \
misc/sort-version \
+ split/filter \
misc/split-a \
misc/split-bchunk \
misc/split-fail \
diff --git a/tests/split/filter b/tests/split/filter
new file mode 100755
index 0000000..52075f9
--- /dev/null
+++ b/tests/split/filter
@@ -0,0 +1,41 @@
+#!/bin/sh
+# Exercise split's new --filter option.
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ split
+
+for total_n_lines in 5 3000 20000; do
+ for i in 2 51 598; do
+ # Don't create too many files/processes.
+ case $i:$total_n_lines in 2:5);; *) continue;; esac
+
+ seq $total_n_lines > in || framework_failure_
+ split -l$i --filter='xz > $FILE.xz' in out- || fail=1
+ xz -dc out-* > out || fail=1
+ compare in out || fail=1
+ rm -f in out*
+ done
+done
+
+# Show how --elide-empty-files works with --filter:
+# split does not run the command (and effectively elides the file)
+# only when the output to that command would have been empty.
+split -e -n 10 --filter='xz > $FILE.xz' /dev/null || fail=1
+stat x?? 2>/dev/null && fail=1
+
+Exit $fail
--
1.7.5.134.g1c08b
- split --filter, nearly ready, Jim Meyering, 2011/04/30
- [PATCH 4/8] split: update NEWS, Jim Meyering, 2011/04/30
- [PATCH 7/8] split: don't rely on knowledge that INT_BUFSIZE_BOUND <= SIG2STR_MAX, Jim Meyering, 2011/04/30
- [PATCH 3/8] split: add tests,
Jim Meyering <=
- [PATCH 6/8] strip: style: use braces around 1-stmt-but-multi-line blocks, Jim Meyering, 2011/04/30
- [PATCH 2/8] split: remove short-named -f option; improve diagnostics, Jim Meyering, 2011/04/30
- [PATCH 5/8] split: mark a string for translation, Jim Meyering, 2011/04/30
- [PATCH 8/8] doc: document split's new --filter=CMD option, Jim Meyering, 2011/04/30
- [PATCH 1/8] split: accept new output --filter option, Jim Meyering, 2011/04/30